// Title: restordata.js
// This file calls the sensordata.csv file and parses its columns 
// 	the assumption is that there are no more that 4 columns in the file
// 	the first column is timestamp [0]; columns [1]-[3] contain sensor data

// Add this to the <body> of your html file: 
//		<pre id="fileDisplayArea"><pre>


 window.onload = function() {
      var dataPoints = [];
        mytimeStamp = 0;
        tempValue = 1;  humValue = 2; lightValue = 3;

		
	
		// First Let's Read a textfile 	
		var fileDisplayArea = document.getElementById('fileDisplayArea');	
		function readTextFile(file)
		{
			var rawFile = new XMLHttpRequest();
			rawFile.open("GET", file, false);
			rawFile.onreadystatechange = function ()
			{
				if(rawFile.readyState === 4)
				{
					if(rawFile.status === 200 || rawFile.status == 0)
					{
						var allText = rawFile.responseText;
						fileDisplayArea.innerText = allText 
						// convert the last value into a number
						 lastValue = parseInt(allText);
					}
				return
				}
			}
			rawFile.send(null);
		}	
		// End of read the text file 
			
        //Define a function named "getDataPointsFromCSV" with parameter "csv"
        function getDataPointsFromCSV(csv) {
			// dataPoints is an array with 2 elements (x,y)
            var dataPoints = csvLines = points = [];
            csvLines = csv.split(/[\r?\n|\r|\n|\r|\n|\r|\n]+/);  // parse FOUR colunms       
            for (var i = 0; i < csvLines.length; i++)
                if (csvLines[i].length > 0) {
                    points = csvLines[i].split(",");
                    //The push() method adds elements to an array
                    dataPoints.push({ 
                        x: parseFloat(points[mytimeStamp]), // Timestamp column
                        y: parseFloat(points[tempValue]),  // First data column	
                    }); 
                }
			
            return dataPoints;
            
        }
     
	$.get("sensordata2.csv", function(data) {	// This is where the data is stored
	
    var chart = new CanvasJS.Chart("chartContainer",
    {
		zoomEnabled: true,  // With this you allow the user to zoom in/out    
      
		title:{
		   text: "Chart With Date-Time Stamps & Inputs For Sensors"   // Title of the chart    
				},
		
		data: [{
		  type: "area",   // you can change it to "line" or "area"
		  color: "blue",   // you can change the color
		  xValueType: "dateTime",
		  dataPoints: getDataPointsFromCSV(data)
			}]	
	});
    
    chart.render();
	});


// ********  START OF THE EGAUGE CHART ********** //
	  // Read the last value of say temparature 
	  readTextFile('lastvalue.txt');

	  var gauge = {
		title:{text: "Latest Temperature Value Recorded"},
		data : { y: lastValue}, //gauge value change it
		maximum : 100
    };	

var chart3 = new CanvasJS.Chart("chartContainer3");

createGauge(chart3);
	

		//Function for gauge
		function createGauge(chart3){

				//Caluculation of remaining parameters to render gauge with the help of doughnut
			gauge.unoccupied = {
							  y: gauge.maximum - gauge.data.y , 
							  color: "#DEDEDE", 
							  toolTipContent: null, 
							  highlightEnabled: false,
							  click : function (){ gauge.unoccupied.exploded = true; }
						  }
		   gauge.data.click = function (){ gauge.data.exploded = true; };
		   if(!gauge.data.color)
				gauge.data.color = "#69C434";
		   gauge.valueText = {text: gauge.data.y.toString(), verticalAlign :"center"};
		   
		   
				var data = {
									type: "doughnut",
									dataPoints: [
						  {
							y: gauge.maximum ,
							color: "transparent",
							toolTipContent: null
						  },
						  gauge.data,
						  gauge.unoccupied
						],
			  };
			
			if(!chart3.options.data)
				chart3.options.data = [];
			chart3.options.data.push(data);
			

			if(gauge.title){
				chart3.options.title = gauge.title;
			}
			
			//For showing value
			if(!chart3.options.subtitles)
				chart3.options.subtitles = [];
			chart3.options.subtitles.push(gauge.valueText);
			

			chart3.render();
		};

// END OF THE FUNCTION
}
